<template>
  <!-- Header -->
  <c-header></c-header>
  <c-header-fixed></c-header-fixed>
  <!-- End header -->

  <!-- About me -->
  <c-about-me></c-about-me>

  <router-view v-slot="{ Component }">
    <transition
      name="custom-classes-transition"
      mode="out-in"
      :enter-active-class="enterActiveClass"
      :leave-active-class="leaveActiveClass"
      ref="routerViewRef"
      v-on:before-enter="beforeEnter"
      v-on:enter="enter"
      v-on:after-enter="afterEnter"
      appear
    >
      <component :is="Component" />
    </transition>
  </router-view>

  <c-footer></c-footer>
  <!-- End router view -->
</template>

<script>
import cHeader from "./components/header.vue";
import cHeaderFixed from "./components/header-fixed.vue";
import cAboutMe from "./components/about-me.vue";
import cFooter from "./components/footer.vue";
import i18n from "./i18n";
import $ from "jquery";

export default {
  name: "App",
  components: {
    cHeader,
    cHeaderFixed,
    cAboutMe,
    cFooter
  },
  watch: {
    $route(to, from) {
      let toDepth = to.path.split("/").length;
      let fromDepth = from.path.split("/").length;
      let enterTransition = toDepth < fromDepth ? "" : "";
      let leaveTransition = enterTransition == "" ? "" : "";
      this.enterActiveClass =
        "animate__animated animate__faster animate__fadeIn" + enterTransition;

      this.leaveActiveClass =
        "animate__animated animate__faster animate__fadeOut" + leaveTransition;
    }
  },
  methods: {
    beforeEnter: function() {
      if (!window.isMobile) {
        // let elementCursorLittle = $(".cursor-little");
        let elementCursorBig = $(".cursor-big");
        // elementCursorLittle.removeClass("hidden");
        elementCursorBig.removeClass("very-big");
      }
    },
    enter: function() {
      window.emitter.emit("enter");
    },
    afterEnter: function() {
      window.emitter.emit("afterEnter");
      if (!window.isMobile) {
        // let elementCursorLittle = $(".cursor-little");
        let elementCursorBig = $(".cursor-big");
        // elementCursorLittle.removeClass("hidden");
        elementCursorBig.removeClass("very-big");
      }
      this.animateScroll();
    },
    isScrolledIntoView: function(elem) {
      var docViewTop = $(window).scrollTop();
      var docViewBottom = docViewTop + $(window).height();

      var elemTop = $(elem).offset().top;
      var elemBottom = elemTop + $(elem).height();

      // Before we hit the element we display it
      if (window.isMobile) {
        elemBottom -= 750;
      } else {
        elemBottom -= 600;
      }

      return elemBottom <= docViewBottom && elemTop >= docViewTop;
    },
    animateScroll: function() {
      let scope = this;
      // If mobile or not
      if (this.mobile == true) {
        // Disable for mobile
        $(".scroll-animate.animate__animated").each(function() {
          $(this).addClass("animate__fadeIn");
        });
        $(".first__experience").removeClass("animate__delay-5s");
        $(".first__experience").addClass("animate__fadeIn");
      } else {
        // Trigger on ready but only fire for the first two element
        let i = 0;
        $(".scroll-animate.animate__animated").each(function() {
          if (scope.isScrolledIntoView(this) === true) {
            $(this).addClass("animate__fadeInDown");
          }
          i++;
          if (i == 2) return false;
        });

        // If element is scrolled into view, fade it in
        $(window).scroll(function() {
          $(".scroll-animate.animate__animated").each(function() {
            if (scope.isScrolledIntoView(this) === true) {
              $(this).addClass("animate__fadeInDown");
            }
          });
        });
      }
    },
    isMobile: function() {
      this.mobile = (function(a) {
        if (
          /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(
            a
          ) ||
          // eslint-disable-next-line no-useless-escape
          /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(
            a.substr(0, 4)
          )
        )
          return true;
        else return false;
      })(navigator.userAgent || navigator.vendor || window.opera);
    },
    anchorHashCheck() {
      if (window.location.hash === this.$route.hash) {
        const el = document.getElementById(this.$route.hash.slice(1));
        if (el) {
          window.scrollTo(0, el.offsetTop);
        }
      }
    }
  },
  data() {
    return {
      enterActiveClass: "",
      leaveActiveClass: "",
      mobile: false,
      publicPath: process.env.BASE_URL,
      translate: i18n.global.getLocaleMessage(this.$i18n.locale)
    };
  },
  created: function() {
    this.isMobile();
  },
  mounted: function() {}
};
</script>

<style lang="scss">
@import "./scss/app.scss";
</style>
